/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "stdafx.h"
#include "Registry.h"
#include <cassert>
#include <vector>

#pragma warning(disable: 4290)

CRegistry::CRegistry(HKEY hkey, 
					 TCHAR const* pszSubKey, 
					 bool bNonVolatile, 
					 bool bCreateIFNotExisted) throw (DWORD)
{
	if (ERROR_SUCCESS != RegCreateKeyEx(hkey
		, pszSubKey
		, 0
		, NULL
		, (bNonVolatile) ? REG_OPTION_NON_VOLATILE : REG_OPTION_VOLATILE
		, KEY_ALL_ACCESS
		, NULL
		, &m_hKey
		, NULL)
		) throw 0;
}

CRegistry::~CRegistry()
{
	RegCloseKey(m_hKey);
}

DWORD CRegistry::GetValue(const char* pKey, tstring &str)
{
	DWORD size = MAX_PATH * sizeof(TCHAR);	
	DWORD type;
	DWORD ErrorCode; 
	std::vector<BYTE> buf(size);

	do {
		buf.resize(size);
		ErrorCode = RegQueryValueEx(m_hKey, pKey, 0, &type, (LPBYTE)&buf[0], &size);
		TCHAR *ch = reinterpret_cast<TCHAR*>(&buf[0]);
	} while (ErrorCode == ERROR_MORE_DATA);

	if (! ((ErrorCode == ERROR_SUCCESS) && (type == REG_SZ))) return 0;
	str.assign(reinterpret_cast<TCHAR*>(&buf[0]), size);
	return type;
}
 
bool CRegistry::GetValue(char const* pKey, DWORD &Value)
{
	DWORD type;
	DWORD size = sizeof(Value);
	bool b = (ERROR_SUCCESS == RegQueryValueEx(m_hKey, pKey, 0, &type, (LPBYTE)&Value, &size));
	return (type == REG_DWORD) && b;
}

#pragma warning(default: 4290)