/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "StdAfx.h"
#include "open_plugin.h"
#include "DialogApplyCommand.h"
#include "Panel.h"
#include "Parser.h"
#include "Executor.h"

using namespace nf;

extern const char* GetMsg(int MsgId);

namespace
{
	const int NUM_ITEMS = 2;
	const int PLUGINSMENU_ITEMS[NUM_ITEMS] = {	
		lg::PLUGINMENU_OPENPANEL
		, lg::PLUGINMENU_APPLYCOMMAND
	};
}

HANDLE nf::open_from_plugins_menu()
{
	std::vector<FarMenuItem> MenuItems(NUM_ITEMS);
	for (unsigned int i = 0; i < NUM_ITEMS; ++i)
	{
		lstrcpy(MenuItems[i].Text, GetMsg(PLUGINSMENU_ITEMS[i]));
		MenuItems[i].Selected = 0;
		MenuItems[i].Checked = 0;
		MenuItems[i].Separator = 0;
	}

	int nSelectedItem = g_PluginInfo.Menu(g_PluginInfo.ModuleNumber
		, -1
		, -1
		, 0	// -  
		, FMENU_AUTOHIGHLIGHT | FMENU_WRAPMODE
		, ""
		, ""
		, ""
		, 0
		, 0
		, &MenuItems[0]
		, static_cast<int>(MenuItems.size())
	);

	if (-1 == nSelectedItem) return INVALID_HANDLE_VALUE;	//user has canceled menu

		
	switch(nSelectedItem) {
	case 0:
		return new CPanel();
		break;
	case 1:
		{
			CDialogApplyCommand dlg;
			if (dlg.ShowModal())
			{
				tstring command = dlg.GetCommandText();
				if (command.find_first_of(_T(":")) == tstring::npos)
				{
					command =  g_pK->GetFirstPluginPrefix() + command;
				}
				return nf::open_from_command_line(command.c_str());
			}
		}
	default:
		return INVALID_HANDLE_VALUE;
	};

	return INVALID_HANDLE_VALUE;
}//open_from_plugins_menu


HANDLE nf::open_from_command_line(TCHAR const* pCmd )
{
	parser::CParser prs;

	kr::tparsed_command cmd;
	g_pK->parse_command(pCmd, cmd);

	switch (cmd.kind)
	{
	case kr::QK_OPEN_PANEL:
		return new nf::CPanel();
		break;
	case kr::QK_OPEN_SHORTCUT:
		if (cmd.shortcut.empty())
		{
			return new nf::CPanel(cmd.catalog);
			break;
		}
	default:
		nf::ExecuteCommand(cmd);
	};
	return INVALID_HANDLE_VALUE;
} //open_from_command_line