/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "StdAfx.h"
#include "registry_remover.h"
#include "stlsoft.h"
#include <list>
#include <shlwapi.h>

namespace
{
	bool recursive_delete_key(winstl::reg_key_t &Key, TCHAR const *SubKey)
	{	//    
		bool bRet = true;
		std::list<tstring> sub_keys;
		winstl::reg_key_t rk(Key.get_key_handle(), SubKey);
		winstl::reg_key_sequence_t seq(rk);
		winstl::reg_key_sequence_t::const_iterator p = seq.begin();
		while (p != seq.end())
		{
			sub_keys.push_back((*p).name().c_str());
			++p;
		};
		while(! sub_keys.empty())
		{
			bRet &= recursive_delete_key(rk,  (*sub_keys.begin()).c_str());
			sub_keys.erase(sub_keys.begin());
		}

		bRet &= ERROR_SUCCESS == ::RegDeleteKey(Key.get_key_handle(), SubKey);
		return bRet;
	}
	bool copy_key(TCHAR const* SrcKey, TCHAR const* TargetKey)
	{	//   
		//    ( )
		//      
		HKEY hKeyTarget;
		if (ERROR_SUCCESS != 
			RegCreateKeyEx(HKEY_CURRENT_USER, TargetKey, 0, NULL, 0
			, KEY_ALL_ACCESS, 0, &hKeyTarget, 0)) 
				return false;

		bool bRet = 
			ERROR_SUCCESS == SHCopyKey(HKEY_CURRENT_USER, SrcKey, hKeyTarget, 0);

		::RegCloseKey(hKeyTarget);
		return bRet;
	}

}

using namespace nf;

bool registry_remover::IsKeysOverloaded(tstring const &SrcKey, tstring const &TargetKey)
{	//,         

	return false;
}

bool registry_remover::remove(tstring const &SrcKey
							  , tstring const*const pTargetKey
							  , bool bDeleteSrc)
{
	if (pTargetKey)
	{
		tstring target_key = *pTargetKey;
	//  
		if (IsKeysOverloaded(SrcKey, target_key))
			return false;
		
		if (! ::copy_key(SrcKey.c_str(), target_key.c_str()))
			return false;
	}

//  
	if (bDeleteSrc)
	{
		tstring ParentKey;
		tstring KeyName;

		tstring::size_type npos =  SrcKey.find_last_of(_T("\\"));
		if (npos == tstring::npos)
		{
			KeyName = SrcKey;
		} else {
			ParentKey.assign(SrcKey.begin(), SrcKey.begin() + npos);
			KeyName.assign(SrcKey.begin() + npos + 1, SrcKey.end());
		}

		winstl::reg_key_t Key(HKEY_CURRENT_USER, ParentKey.c_str());	
		if (! ::recursive_delete_key(Key, KeyName.c_str()))
			return false;
	}

	return true;
}

